% zyz euler angles for flipped pen
% Correspond to slightly modified altitude, azimuth, and twist angles
% from wintab

syms t z a


Raz_z = [ cos(z) -sin(z)  0 ; sin(z)   cos(z)    0 ;  0   0   1 ];
Ral_y = [ cos(a)  0  sin(a) ;  0    1    0 ; -sin(a)  0  cos(a) ];
Rtw_z = [ cos(t) -sin(t)  0 ; sin(t)   cos(t)    0 ;  0   0   1 ];

roty180 = [ -1 0 0; 0 1 0; 0 0 -1 ];

R = roty180 * Raz_z * Ral_y * Raz_z.' * Rtw_z;
%R =  Raz_z * Ral_y * Raz_z.' * Rtw_z;

cth = (trace(R) - 1)/2; wprime = [ R(3,2) - R(2,3); R(1,3) - R(3,1);
R(2,1) - R(1,2) ]; 
wcoeff = 1/(2*sqrt(1-cth*cth)); 
w = wcoeff * wprime;


%R =
% 
%[ (-cz^2*ca-sz^2)*ct+(-cz*ca*sz+sz*cz)*st, -(-cz^2*ca-sz^2)*st+(-cz*ca*sz+sz*cz)*ct,  -cz*sa]
%[   (cz*ca*sz-sz*cz)*ct+(sz^2*ca+cz^2)*st,   -(cz*ca*sz-sz*cz)*st+(sz^2*ca+cz^2)*ct,  sz*sa]
%[                       cz*sa*ct+sz*sa*st,                       -cz*sa*st+sz*sa*ct,    -ca]

tr = R(1,1) + R(2,2) + R(3,3);

% tr = ( (cz^2*+sz^2)*ca+ sz^2+cz^2)*ct + ca;
% tr = ( (   1.0    )*ca+ 1.0)*ct + ca;
% tr = ct*(ca+1)+ca;

% r32mr23 = (st*cz-ct*sz-sz)*sa
r32mr23 = R(3,2)-R(2,3);


% r21mr12 = (sz^2+cz^2)*(ca+1)*st
% r21mr12 = (ca+1)*st
r21mr12 = R(2,1)-R(1,2);

% r13mr31 = sa*(cz+ct*cz+st*sz)
% r13mr31 = sa*( cz+ct*cz + st*sz)
r13mr31 = R(1,3)-R(3,1);



