% zyz euler angles
% Correspond to slightly modified altitude, azimuth, and twist angles
% from wintab

syms st ct sz cz sa ca


Raz_z = [ cz -sz  0 ; sz   cz    0 ;  0   0   1 ];
Ral_y = [ ca  0  sa ;  0    1    0 ; -sa  0  ca ];
Rtw_z = [ ct -st  0 ; st   ct    0 ;  0   0   1 ];

R = Raz_z * Ral_y * Raz_z.' * Rtw_z;

cth = (trace(R) - 1)/2; wprime = [ R(3,2) - R(2,3); R(1,3) - R(3,1);
R(2,1) - R(1,2) ]; 
wcoeff = 1/(2*sqrt(1-cth*cth)); 
w = wcoeff * wprime;


%ans =
% 
% [  (cz^2*ca+sz^2)*ct+(cz*ca*sz-sz*cz)*st, -(cz^2*ca+sz^2)*st+(cz*ca*sz-sz*cz)*ct,  cz*sa]
% [  (cz*ca*sz-sz*cz)*ct+(sz^2*ca+cz^2)*st, -(cz*ca*sz-sz*cz)*st+(sz^2*ca+cz^2)*ct,  sz*sa]
% [                      sa*(-ct*cz-st*sz),                       sa*(st*cz-ct*sz),     ca]

% tr = ( (cz^2*+sz^2)*ca+ sz^2+cz^2)*ct + ca;
% tr = ( (   1.0    )*ca+ 1.0)*ct + ca;
tr = ct*(ca+1)+ca;

r32mr23 = (st*cz-ct*sz-sz)*sa

% r21mr12 = (sz^2+cz^2)*(ca+1)*st
r21mr12 = (ca+1)*st

% r13mr31 = sa*(cz+ct*cz+st*sz)
r13mr31 = sa*( cz+ct*cz + st*sz)


% R =
%  
% [  ct*cz*ca-st*sz, -st*cz*ca-ct*sz,           cz*sa]
% [  sz*ca*ct+st*cz, -sz*ca*st+ct*cz,           sz*sa]
% [          -ct*sa,           st*sa,              ca]


